BigIntegerMath
Date: 2016-05-24

com.google.common.math

## Class BigIntegerMath

- java.lang.Object
- - com.google.common.math.BigIntegerMath

-     @GwtCompatible(emulated=true)
      public final class BigIntegerMath
      extends java.lang.Object

  A class for arithmetic on values of type `BigInteger`.

  The implementations of many methods in this class are based on material from Henry S. Warren, Jr.'s Hacker's Delight, (Addison Wesley, 2002).

  Similar functionality for `int` and for `long` can be found in `IntMath` and `LongMath` respectively.

  Since:
    11.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.math.BigInteger` | `binomial(int n, int k)` Returns `n` choose `k`, also known as the binomial coefficient of `n` and `k`, that is, `n! / (k! (n - k)!)`.
    `static java.math.BigInteger` | `divide(java.math.BigInteger p, java.math.BigInteger q, java.math.RoundingMode mode)` Returns the result of dividing `p` by `q`, rounding using the specified `RoundingMode`.
    `static java.math.BigInteger` | `factorial(int n)` Returns `n!`, that is, the product of the first `n` positive integers, or `1` if `n == 0`.
    `static boolean` | `isPowerOfTwo(java.math.BigInteger x)` Returns `true` if `x` represents a power of two.
    `static int` | `log10(java.math.BigInteger x, java.math.RoundingMode mode)` Returns the base-10 logarithm of `x`, rounded according to the specified rounding mode.
    `static int` | `log2(java.math.BigInteger x, java.math.RoundingMode mode)` Returns the base-2 logarithm of `x`, rounded according to the specified rounding mode.
    `static java.math.BigInteger` | `sqrt(java.math.BigInteger x, java.math.RoundingMode mode)` Returns the square root of `x`, rounded with the specified rounding mode.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### isPowerOfTwo

          public static boolean isPowerOfTwo(java.math.BigInteger x)

      Returns `true` if `x` represents a power of two.

    - #### log2

          public static int log2(java.math.BigInteger x,
                 java.math.RoundingMode mode)

      Returns the base-2 logarithm of `x`, rounded according to the specified rounding mode.
      Throws:
        `java.lang.IllegalArgumentException` - if `x <= 0`
        `java.lang.ArithmeticException` - if `mode` is `RoundingMode.UNNECESSARY` and `x` is not a power of two

    - #### log10

          @GwtIncompatible(value="TODO")
          public static int log10(java.math.BigInteger x,
                                       java.math.RoundingMode mode)

      Returns the base-10 logarithm of `x`, rounded according to the specified rounding mode.
      Throws:
        `java.lang.IllegalArgumentException` - if `x <= 0`
        `java.lang.ArithmeticException` - if `mode` is `RoundingMode.UNNECESSARY` and `x` is not a power of ten

    - #### sqrt

          @GwtIncompatible(value="TODO")
          public static java.math.BigInteger sqrt(java.math.BigInteger x,
                                                       java.math.RoundingMode mode)

      Returns the square root of `x`, rounded with the specified rounding mode.
      Throws:
        `java.lang.IllegalArgumentException` - if `x < 0`
        `java.lang.ArithmeticException` - if `mode` is `RoundingMode.UNNECESSARY` and `sqrt(x)` is not an integer

    - #### divide

          @GwtIncompatible(value="TODO")
          public static java.math.BigInteger divide(java.math.BigInteger p,
                                                         java.math.BigInteger q,
                                                         java.math.RoundingMode mode)

      Returns the result of dividing `p` by `q`, rounding using the specified `RoundingMode`.
      Throws:
        `java.lang.ArithmeticException` - if `q == 0`, or if `mode == UNNECESSARY` and `a` is not an integer multiple of `b`

    - #### factorial

          public static java.math.BigInteger factorial(int n)

      Returns `n!`, that is, the product of the first `n` positive integers, or `1` if `n == 0`.

      Warning: the result takes O(n log n) space, so use cautiously.

      This uses an efficient binary recursive algorithm to compute the factorial with balanced multiplies. It also removes all the 2s from the intermediate products (shifting them back in at the end).

      Throws:
        `java.lang.IllegalArgumentException` - if `n < 0`

    - #### binomial

          public static java.math.BigInteger binomial(int n,
                                      int k)

      Returns `n` choose `k`, also known as the binomial coefficient of `n` and `k`, that is, `n! / (k! (n - k)!)`.

      Warning: the result can take as much as O(k log n) space.

      Throws:
        `java.lang.IllegalArgumentException` - if `n < 0`, `k < 0`, or `k > n`